#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id
#
# Information:
# Hilfsprozeduren geladen durch Init.tcl
# keine xotcl Erweiterungen

# Hilfsprozeduren fr das Behandeln von tDom 
# spter in einen anderen Modul kappseln
#
proc tdom_getvaluelist domNode {
    set vlist_node [lindex [$domNode selectNodes child::valuelist] 0]
    if {$vlist_node==""} return
    set valuelist {}
    foreach item_node [$vlist_node selectNodes child::item] {
	lappend valuelist [$item_node text]
    }
    return $valuelist
}
proc tdom_setvaluelist {domNode vlist} {
    set rdom_doc [$domNode ownerDocument]
    #Alte valuelist lschen
    foreach vlist_node [$domNode selectNodes child::valuelist] {
	$domNode removeChild $vlist_node
    }
    set vlnode [$rdom_doc createElement valuelist]
    $domNode appendChild $vlnode
    foreach item $vlist {
	set nodeitem [$rdom_doc createElement item]
	$vlnode appendChild $nodeitem
	$nodeitem appendChild [$rdom_doc createTextNode $item]
    }
}
proc tdom_getpername {domNode name} {
    set node [lindex [$domNode selectNodes child::$name] 0]
    if {$node==""} return
    return [$node text]
}
proc tdom_setpername {domNode name value} {
    set rdom_doc [$domNode ownerDocument]
    set node [lindex [$domNode selectNodes child::$name] 0]
    if {$node==""} {
	if {$value==""} return
	set node [$rdom_doc createElement $name]
	$domNode appendChild $node
    } else {
	if {$value==""} {
	    [$node parentNode] removeChild $node
	    return
	}
	foreach cnode [$node childNodes] {
	    $node removeChild $cnode
	}
    }
    $node appendChild [$rdom_doc createTextNode $value]
}
proc tdom_findpername {domNode tagname name} {
    # Suche Wurzel Node
#     set rnode [[$domNode ownerDocument] documentElement]
#     foreach node [$rnode getElementsByTagName $tagname] {
# 	if {[$node hasAttribute name] && [$node getAttribute name]==$name} {
#puts "prima $node"
# 	    return $node
# 	}
#     }
#puts "ERROR: node per name not found"
    #puts "Found Nodes $domNode $tagname $name $domNode selectNodes //descendant::${tagname}\[@name=\"${name}\"\]"
    return [$domNode selectNodes //child::$tagname\[@name=\"$name\"\]]
}
proc tdom_getprimattr {table_node} {
     return [$table_node selectNodes {child::node()[not(self::table)]/descendant-or-self::attr[@primary_key="1"]/attribute::name}]
}
# Setzt eine TclX Keyed List als tDom Tag Attribute
# in defattr knnen die Default Werte definiert werden die jodoch nicht gesetzt werden
# attr definiert nur die Attribute die gesetzt werden sollen
proc tdom_keyl2attr {domNode keyl {defattr {}} {attr {}}} {
    #puts "k2a $keyl $defattr $attr"
    if {$defattr!=""} {
	set defk [keylkeys defattr]
    } else {
	set defk {}
    }
    #puts "KL $keyl $defattr DEF $defk"
    foreach key [keylkeys keyl] {
	if {$attr!="" && ![lcontain $attr $key]} continue
	if {[lcontain $defk $key] && [keylget defattr $key]==[keylget keyl $key]} {
	    if {[$domNode hasAttribute $key]} {
		# Die Defaultwerte werden entfern
		# Das soll die App. bernehemen
		#puts "entferne $key"
		$domNode removeAttribute $key
	    }
	    continue
	}
	$domNode setAttribute $key [keylget keyl $key]
    }
}
# Liefert tDOM Tag Attribute als Tcl Keyed List in attr knnen die Attribute 
# gesetzt werden, die ausgelesen werden sollen
# wenn keins dann alle
proc tdom_attr2keyl {domNode {attr {}}} {
    set ret {}
    foreach key [$domNode attributes] {
	if {$attr!="" && ![lcontain $attr $key]} continue
	if {[$domNode hasAttribute $key]} {
	    keylset ret $key [$domNode getAttribute $key]
	}
    }    
    return $ret
}
proc tdom_setdefaults {kl_ref defkl} {
    upvar $kl_ref kl
    set klk [keylkeys kl]
    foreach key [keylkeys defkl] {
	if {![lcontain $klk $key]} {
	    keylset kl $key [keylget defkl $key]
	}
    }
}
# berprft zwei tclx keylist auf Gleicheit
# bergabe per Referenc
proc keylequal {kl1 kl2} {
    upvar $kl1 mykl1 $kl2 mykl2
    #puts "$mykl1 $mykl2"
    # berprfen der gleichheit der schlssel
    if {[lsort [keylkeys mykl1]]!=[lsort [keylkeys mykl2]]} {
	return 0
    }
    foreach key [keylkeys mykl1] {
	if {[keylget mykl1 $key]!=[keylget mykl2 $key]} {
	    return 0
	}
    }
    return 1
}
#
# Eigene Implementierung (nach tclx) von Mengen Operationen
#
# eigene intersect tclx Prozedur
proc schnittMenge {list1 list2} {
    set intersectList ""
    set list1 [lsort $list1]
    set list2 [lsort $list2]
    while {1} {
        if {[lempty $list1] || [lempty $list2]} break
        set compareResult [string compare [lindex $list1 0] [lindex $list2 0]]
        if {$compareResult < 0} {
            lvarpop list1
            continue
        }
        if {$compareResult > 0} {
            lvarpop list2
        continue
        }
        lappend intersectList [lvarpop list1]
        lvarpop list2
    }
    return $intersectList
}
# eigene intersect3 erste list
# gib alle Elemente zurck, die in der list1 aber nicht in list2 sind
proc minusMenge {list1 list2} {
    set la1(0) {} ; unset la1(0)
    foreach v $list1 {
        set la1($v) {}
    }
    foreach elem $list2 {
        if {[info exists la1($elem)]} {
            unset la1($elem)
        }
    }
    return [array names la1]
}
proc addMenge {list1 list2} {
    set la1(0) {} ; unset la1(0)
    foreach v $list1 {
        set la1($v) {}
    }
    foreach v $list2 {
        set la1($v) {}
    }
    return [array names la1]
}
#
# 
proc handle_help {} {
    global tcl_platform progdir
    if {$tcl_platform(platform)=="windows"} {
        winhelp [file join $progdir tkmatrix.hlp]
    } else {
        global helpdir lan option errorInfo
        if {$option(netscape_remote)} {
            set ret [catch {exec netscape -remote "openFile ([file join $helpdir $lan(standard.helpfile)])"}]
            if {$ret!=0} {
                if {"no"==[tk_messageBox -title $lan(dialog.errormsg) \
			       -message $lan(dialog.lunch_browser) \
			   -icon question -type yesno]} {
                    return
                }
            } else {
                return
            }
        }
        set command [format $option(htmlhelpviewer) [file join $helpdir $lan(standard.helpfile)]]
        #puts "com $command helpdir $helpdir"
        set ret [catch { eval exec $command & }]
        if {$ret != 0} {
            tk_messageBox -title $lan(dialog.errormsg) -message "$lan(dialog.nohelpviewer) Command:\"$command\" Error:\"$errorInfo\"" -icon error -type ok
            return
        }
    }     
}
proc handle_about {{kname XDobry}} {
    global lan progdir
    set w .aboutdialog
    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w $lan(dialog.aboutdialogtitle)
    wm iconname $w Dialog
    wm protocol $w WM_DELETE_WINDOW { }

    catch {focus $oldFocus}    

    frame $w.bot
    frame $w.buttons -relief raised -bd 1
    frame $w.top -relief raised -bd 1

    message $w.msg -text "Database-Application-System: Xdobry\n\
new approach system for datebase form generation\n\
program: $kname\n\
Version 0.12 Release 0\n\
Date 11.2000\n\
Author: Artur Trzewik\n\
all rights reserved\n\
email: mail@xdobry.de\n\
homepage: http://www.xdobry.de" -width 1000
    label $w.image -image [tix getimage artur]
    button $w.ok -text $lan(standard.ok) -command "set mywait ok"

    grid  $w.ok -in $w.bot -column 0 -row 0 -sticky ew -padx 10  
    
    pack $w.image -side left -padx .5c -pady .5c -in $w.top 
    pack $w.msg -side left -in $w.top
    pack $w.top -side top -fill both -expand 1
    pack $w.buttons
    pack $w.bot -side bottom -fill both

    bind $w <Destroy> {set mywait cancel}

    wm withdraw $w
    update idletasks
    set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	    - [winfo vrootx [winfo parent $w]]]
    set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	    - [winfo vrooty [winfo parent $w]]]
    wm geom $w +$x+$y
    wm deiconify $w

    # 7. Set a grab and claim the focus too.

    set oldFocus [focus]
    set oldGrab [grab current $w]
    if {$oldGrab != ""} {
	set grabStatus [grab status $oldGrab]
    }
    grab $w
    focus $w
    

    # 8. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.  Restore the focus
    # before deleting the window, since otherwise the window manager
    # may take the focus away so we can't redirect it.  Finally,
    # restore any grab that was in effect.

    tkwait variable mywait
    catch {image delete image2a}
    catch {focus $oldFocus}
    catch {
	# It's possible that the window has already been destroyed,
	# hence this "catch".  Delete the Destroy handler so that
	# tkPriv(button) doesn't get reset by it.

	bind $w <Destroy> {}
	destroy $w
    }
    if {$oldGrab != ""} {
	if {$grabStatus == "global"} {
	    grab -global $oldGrab
	} else {
	    grab $oldGrab
	}
    }
}
proc wwwlink_autor {} {
    set homepage http://www.xdobry.de
    global tcl_platform progdir
    if {$tcl_platform(platform)=="windows"} {
        tk_messageBox -title $lan(errormsg) -message "$lan(dialog.nowww_winsupport) \n$ homepage" -icon error -type ok
        return
    } else {
        global helpdir lan option errorInfo
        if {$option(netscape_remote)} {
            set ret [catch {exec netscape -remote "openURL ($homepage)"}]
            if {$ret!=0} {
                if {"no"==[tk_messageBox -title $lan(errormsg) \
			       -message $lan(dialog.lunch_browser) \
			       -icon question -type yesno]} {
                    return
                }
            } else {
                return
            }
        }
        set command [format $option(htmlhelpviewer) $homepage]
        #puts "com $command helpdir $helpdir"
	set ret [catch { eval exec $command & }]          
	if {$ret != 0} {
            tk_messageBox -title $lan(dialog.errormsg) -message "$lan(dialog.nohelpviewer) Command:\"$command\" Error:\"$errorInfo\"" -icon error -type ok
            return
        }
    }
}

   
